//PLEASE READ THE README.TXT FILE FIRST!!!
/*
GRN algorithm in an artificial evolution framework to model biological clocks
Copyright (C) 2005  Johannes Knabe
j.f.knabe@herts.ac.uk

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/




/*
Deviation from perfect sin (wavelength=20)
Pulse: 26.018938081200382
Step: 14.744993941299825
posSig: 12.627503029350088
sig: 0.0
*/
import java.util.*;
import java.io.*;
 
public class main { 

public static String resultsDir;
public static int generations=250;
public static int popSize=250;
public static int minFunc=0;//currently there are 16 functions available,
public static int maxFunc=16;//see getIn() in QuickGRN/KnabeGRN.java for details

public static void runKnabeSeries(int numberOfGenes,int fitnessMeasure){
//*run a whole evolution series:
KnabeGRN.geneNo=numberOfGenes;
resultsDir="results(KnabeGRN"+fitnessMeasure+"FitFunc"+numberOfGenes+"Genes)/";
for(int func=minFunc;func<maxFunc;func++){     //for every input function
 for(int count=0;count<10;count++){//run a population 10 times
  System.out.print("Doing Population with input func "+func+"; internal number "+count);
  System.out.println(" - best fitness: "+runKnabePopulation(func,fitnessMeasure,count));
  System.out.println(" results: see "+resultsDir);
  }
 }
}

public static void runQuickSeries(int numberOfGenes,int fitnessMeasure){
//*run a whole evolution series:
QuickGRN.geneNo=numberOfGenes;
resultsDir="results(QuickGRN"+fitnessMeasure+"FitFunc"+numberOfGenes+"Genes)/";
for(int func=minFunc;func<maxFunc;func++){     //for every input function
 for(int count=0;count<10;count++){//run a population 10 times
  System.out.print("Doing Population with input func "+func+"; internal number "+count);
  System.out.println(" - best fitness: "+runQuickPopulation(func,fitnessMeasure,count));
  System.out.println(" results: see "+resultsDir);
  }
 }
}

public static double[] avgGenomeLength;
public static double[] avgPerformance;
public static double[] bestGenomeLength;
public static double[] bestPerformance;
public static double[] allTimeBestGenomeLength;
public static double[] allTimeBestPerformance;

// BEGIn Saveall
public static void runKnabeSeriesSaveAll(int numberOfGenes,int fitnessMeasure){
//*run a whole evolution series:
KnabeGRN.geneNo=numberOfGenes;
resultsDir="results(KnabeGRN"+fitnessMeasure+"FitFunc"+numberOfGenes+"Genes)/";
// for(int func=minFunc;func<maxFunc;func++){     //for every input function
int func=0;
bestGenomeLength=new double[generations];
avgGenomeLength =new double[generations];
avgPerformance  =new double[generations];
bestPerformance =new double[generations];
allTimeBestGenomeLength=new double[generations];
allTimeBestPerformance=new double[generations];
for(int i=0;i<allTimeBestPerformance.length;i++){
  allTimeBestPerformance[i]=9999.0;
}
 for(int count=0;count<10;count++){//run a population 10 times
  System.out.print("Doing Population with input func "+func+"; internal number "+count);
  System.out.println(" - best fitness: "+runKnabePopulationSaveAll(func,fitnessMeasure,count));
  System.out.println(" results: see "+resultsDir);
  int i=249;
  System.out.println("intermediate stand: "+allTimeBestPerformance[i]+" "+allTimeBestGenomeLength[i]+" "+bestPerformance[i]+" "+bestGenomeLength[i]+" "+avgPerformance[i]+" "+avgGenomeLength[i]); 
  }
for(int i=0;i<avgPerformance.length;i++){
  avgGenomeLength[i]/=((double)(popSize*10.0));
  avgPerformance[i]/=((double)(popSize*10.0));
  bestGenomeLength[i]/=10.0;
  bestPerformance[i]/=10.0;
}
File file = null;
PrintWriter out = null;
try{
  file = new File(resultsDir+"/"+func+"/overview.txt");
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(file)));
}
catch(Exception e){
  System.err.println("Error creating output file!\n"+e);
}
out.println("#legend: best performance of all runs, best genome length of best performing of all runs, mean over runs of performance of best, genome length of best performing, avg performance of all individuals, avg genome length of all individuals");
for(int i=0;i<avgPerformance.length;i++){
  out.println(i+" "+allTimeBestPerformance[i]+" "+allTimeBestGenomeLength[i]+" "+bestPerformance[i]+" "+bestGenomeLength[i]+" "+avgPerformance[i]+" "+avgGenomeLength[i]);
}
out.close();
//  } end of "for(int func=minFunc;func<maxFunc;func++){     //for every input function"
}
public static double runKnabePopulationSaveAll(int whatFunction,int whatMeasure,int internalNo){
int[] genome=new int[KnabeGRN.geneNo*10+39];//12:4 for a cis site + 2 for cis delimiters + 4 for protein produced + 2 for gene delimiters
java.util.Random rand=new java.util.Random();
int next;
for(int i=0;i<genome.length;i++){
  next=rand.nextInt(2);
  //System.out.print(next+",");
  genome[i]=next;
}
for(int i=0;i<KnabeGRN.geneNo;i++){
  genome[i*10+9]=3;
  genome[i*10+4]=2;
}

KnabeGRN z=new KnabeGRN(genome);

KnabeGRN.setInputFunction(whatFunction);
KnabeGRN.setFitFunction(whatMeasure);
File file = null;
PrintWriter out = null;
String currDir=resultsDir+whatFunction+"/"; //e.g. results/0/
try{//make directory (if not already existing...)
  file = new File(currDir);
  file.mkdirs();}
catch(Exception e){}
try{
  file = new File(currDir+internalNo+".txt");
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(file)));
}
catch(Exception e){
  System.err.println("Error creating output file!\n"+e);
}
KnabeEvo.popSize=popSize;
KnabeEvo test=new KnabeEvo(z);
double bestFit=9999.0;
double currFit=0;
out.println("#Knabe GRN; run number "+internalNo+"; using input function "+whatFunction+"; the number of genes was "+QuickGRN.geneNo);
out.println("#generation / fittest");

try{//make directory (if not already existing...)
  File file2 = new File(currDir+internalNo+"/");
  file2.mkdirs();}
catch(Exception e){}

for(int i=0;i<generations;i++){

  try{//make directory (if not already existing...)
  File file2 = new File(currDir+internalNo+"/Gen"+i);
  file2.mkdirs();}
  catch(Exception e){}

  test.processGen();
  out.print(i+" ");
  z=(KnabeGRN)test.getFittest();
  currFit=z.getFitness();
  out.println(" "+currFit);
  //System.out.println(i+" "+currFit);
  bestPerformance[i]+=currFit;
  bestGenomeLength[i]+=(z.getGenome()).length;
  if(currFit<allTimeBestPerformance[i]){
    allTimeBestPerformance[i]=currFit;
    allTimeBestGenomeLength[i]=(double)(z.getGenome()).length;
    }
  if(currFit<bestFit){//only save if better than last time!
    z.toFile(currDir+internalNo+"/bestOfGen"+i);
    bestFit=currFit;
    }
  for(int j=0;j<test.currentPop.length;j++){
    avgGenomeLength[i]+=(test.currentPop[j].getGenome()).length;
    avgPerformance[i] +=test.currentPop[j].getFitness();
    test.currentPop[j].toFile(currDir+internalNo+"/Gen"+i+"/"+j);
    }
  test.nextGen();
}
out.close();
return bestFit;
}
// ENd Saveall



public static double runKnabePopulation(int whatFunction,int whatMeasure,int internalNo){
int[] genome=new int[KnabeGRN.geneNo*10+39];//12:4 for a cis site + 2 for cis delimiters + 4 for protein produced + 2 for gene delimiters
java.util.Random rand=new java.util.Random();
int next;
for(int i=0;i<genome.length;i++){
  next=rand.nextInt(2);
  //System.out.print(next+",");
  genome[i]=next;
}
for(int i=0;i<KnabeGRN.geneNo;i++){
  genome[i*10+9]=3;
  genome[i*10+4]=2;
}

KnabeGRN z=new KnabeGRN(genome);

KnabeGRN.setInputFunction(whatFunction);
KnabeGRN.setFitFunction(whatMeasure);
File file = null;
PrintWriter out = null;
String currDir=resultsDir+whatFunction+"/"; //e.g. results/0/
try{//make directory (if not already existing...)
  file = new File(currDir);
  file.mkdirs();}
catch(Exception e){}
try{
  file = new File(currDir+internalNo+".txt");
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(file)));
}
catch(Exception e){
  System.err.println("Error creating output file!\n"+e);
}
KnabeEvo.popSize=popSize;
KnabeEvo test=new KnabeEvo(z);
double bestFit=9999.0;
double currFit=0;
out.println("#Knabe GRN; run number "+internalNo+"; using input function "+whatFunction+"; the number of genes was "+QuickGRN.geneNo);
out.println("#generation / fittest");

try{//make directory (if not already existing...)
  File file2 = new File(currDir+internalNo+"/");
  file2.mkdirs();}
catch(Exception e){}

for(int i=0;i<generations;i++){
  test.processGen();
  out.print(i+" ");
  z=(KnabeGRN)test.getFittest();
  currFit=z.getFitness();
  out.println(" "+currFit);
  //System.out.println(i+" "+currFit);
  if(currFit<bestFit){//only save if better than last time!
    z.toFile(currDir+internalNo+"/bestOfGen"+i);
    bestFit=currFit;
    }
  test.nextGen();
}
out.close();
return bestFit;
}

public static void showStructure(KnabeGRN z){
System.out.println("Be careful with drawing conclusions from the follwing structure data as unused as well as disfunctional stuff is hard to remove automatically and thus it is in!");
int [] protInteractions=new int[8];
double cisSitesNum=0;
int maxCisNum=0;
double bindingNum=0;
int maxBindNum=0;
int [] curr;
KnabeGene ttt=null;
for(int i=0;i<z.genes.length;i++){
 ttt=(KnabeGene) z.genes[i];
 if(ttt==null){
   System.out.println("Gene "+i+" is not used.");
   continue;
 }
 System.out.print("Gene "+i+" has "+ttt.geneCisReceptorSites.length+" cis-sites and is ");
 if(ttt.geneOutputActivity==0)
  System.out.print("default 'off'");
 else
  System.out.print("default 'on'");
 System.out.println(" and produces protein "+ttt.geneOutputProtein);
 cisSitesNum+=ttt.geneCisReceptorSites.length;
 if(maxCisNum<ttt.geneCisReceptorSites.length)
   maxCisNum=ttt.geneCisReceptorSites.length;
 for(int j=0;j<ttt.geneCisReceptorSites.length;j++){
  curr=ttt.getCisSite(j);
  System.out.print(" cis-site "+j+" is ");
  if(curr[0]==0)
    System.out.print("inhibitory");
  else
    System.out.print("activatory");
  System.out.print(" and needs proteins:");
  if(maxBindNum<curr.length-1)
    maxBindNum=curr.length-1;
  bindingNum+=curr.length-1;
  for(int l=1;l<curr.length-1;l++){
    protInteractions[curr[l]]++;
    System.out.print(curr[l]+"+");
    }
  System.out.println(""+curr[curr.length-1]);
  protInteractions[curr[curr.length-1]]++;
 }
}
int maxActiveProt=0;
double usedProteins=0;
double avgActiveProt=0;
for(int i=0;i<protInteractions.length;i++){
  if(protInteractions[i]!=0)
    usedProteins++;
  avgActiveProt+=protInteractions[i];
  if(maxActiveProt<protInteractions[i])
    maxActiveProt=protInteractions[i];
  System.out.println("Protein "+i+" is needed on "+protInteractions[i]+" cis-sites.");
  }
System.out.println("average number of cis-sites per gene (considering disfunctional genes!): "+(cisSitesNum/(z.genes.length*1.0))+" ; max: "+maxCisNum);
System.out.println("average number of binding sites per cis-site (again disfunctional included): "+(bindingNum/cisSitesNum)+" ; max: "+maxBindNum);
System.out.println("average number (over "+(int)usedProteins+" of 8 proteins used) of interactions a protein is involved: "+(avgActiveProt/usedProteins)+" ; max: "+maxActiveProt);
}

public static double runQuickPopulation(int whatFunction,int whatMeasure,int internalNo){
int[] genome=new int[QuickGRN.geneNo*8+39];
java.util.Random rand=new java.util.Random();
int next;
for(int i=0;i<genome.length;i++){
  next=rand.nextInt(2);
  //System.out.print(next+",");
  genome[i]=next;
}
QuickGRN z=new QuickGRN(genome);

QuickGRN.setInputFunction(whatFunction);
QuickGRN.setFitFunction(whatMeasure);
File file = null;
PrintWriter out = null;
String currDir=resultsDir+whatFunction+"/"; //e.g. results/0/
try{//make directory (if not already existing...)
  file = new File(currDir);
  file.mkdirs();}
catch(Exception e){}
try{
  file = new File(currDir+internalNo+".txt");
  out = new PrintWriter(
	new OutputStreamWriter(
	new FileOutputStream(file)));
}
catch(Exception e){
  System.err.println("Error creating output file!\n"+e);
}

QuickEvo.popSize=popSize;
QuickEvo test=new QuickEvo(z);
double bestFit=9999.0;
double currFit=0;
out.println("#Quick GRN; run number "+internalNo+"; using input function "+whatFunction+"; the number of genes was "+QuickGRN.geneNo);
out.println("#generation / fittest");

try{//make directory (if not already existing...)
  File file2 = new File(currDir+internalNo+"/");
  file2.mkdirs();}
catch(Exception e){}

for(int i=0;i<generations;i++){
  test.processGen();
  out.print(i+" ");
  z=(QuickGRN)test.getFittest();
  currFit=z.getFitness();
  out.println(" "+currFit);
  if(currFit<bestFit){//only save if better than last time!
    z.toFile(currDir+internalNo+"/bestOfGen"+i);
    bestFit=currFit;
    }
  test.nextGen();
}
out.close();
return bestFit;
}

public static void main(String[] args){
// runKnabeSeriesSaveAll(9,1);

  runKnabeSeries(9,0);
  runKnabeSeries(9,1);
  runKnabeSeries(5,0);
  runKnabeSeries(5,1);

/*
  runQuickSeries(9,0);
  runQuickSeries(9,1);
  runQuickSeries(5,1);
  runQuickSeries(5,0);
*/

/*//for seeing gene interactions
KnabeGRN.geneNo=5;
KnabeGRN.setInputFunction(6);
KnabeGRN.setFitFunction(1);
int[] geno=new int[] {0,0,0,2,2,1,1,0,0,1,1,1,2,0,2,1,2,0,0,0,1,2,1,2,1,0,1,1,1,0,1,1,0,1,2,0,0,1,1,1,2,1,1,0,1,3,1,1,0,1,0,2,1,1,0,1,1,0,0,1,0,0,0,1,2,1,2,0,1,1,1,0,2,0,0,2,0,3,1,1,1,1,1,2,1,1,0,1,1,0,1,0,0,1,1,0,1,1,1,1,2,0,0,2,1,2,1,1,0,1,0,0,2,1,0,2,1,2,1,1,0,2,1,0,2,0,3,1,1,1,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,0,1,0,0,0,0,0,0,1,0,0,0,1,3,0,1,0,1,2,0,1,0,1,1,1,2,1,2,2,2,1,2,0,2,1,1,0,1,1,0,1,0,0,1,1,0,1,1,0,1,1,0,0,2,0,0,0,1,1,0,0,2,1,0,2,1,0,2,0,1,1,0,1,1,3,1,0,0,1,1,0,0,1,0,1,0,1,0,0,1,0,1,0,0,1,0,0,1,1,1,0,0,0,0,1,0,1,1,0,0,0,1,1,0};
KnabeGRN z=new KnabeGRN(geno);
showStructure(z);
*/

/*FOR lifetime graph
KnabeGRN.geneNo=9;
KnabeGRN.setInputFunction(70);
KnabeGRN.setFitFunction(70);
int[] geno=new int[] {0,0,0,0,1,1,1,1,1,0,0,0,0,1,3,0,1,1,0,2,0,1,2,1,1,1,0,1,1,1,1,1,2,0,1,0,1,1,2,1,1,0,1,3,0,1,0,1,3,0,0,1,0,0,1,1,1,1,1,1,0,0,1,0,0,1,3,1,0,0,1,1,2,2,1,0,1,0,2,1,1,1,0,0,2,2,2,1,0,0,1,0,1,0,3,0,1,1,2,1,1,0,1,1,0,2,0,1,0,2,0,0,1,0,1,2,1,2,1,1,1,1,1,1,1,2,1,1,1,0,1,3,0,0,1,0,2,1,1,2,1,1,1,1,1,1,1,2,1,2,1,2,1,1,1,1,1,2,1,0,0,1,0,0,0,1,0,2,1,0,0,2,0,1,1,1,3,1,1,0,0,0,2,2,0,2,2,1,0,2,2,0,0,2,2,1,2,1,2,1,1,1,0,3,0,0,0,0,1,0,0,3,1,1,1,0,1,1,0,1,0,0,0,1,1,0,1,1,0,0,0,1,1,0,1,0,1,0,1,1,1,1,0,0,1,1,1,0,1,0,0};
// {1,3,0,1,1,0,1,1,0,0,0,0,0,0,3,1,0,2,1,2,1,0,2,1,2,1,0,2,1,0,1,1,2,0,0,1,1,1,1,0,1,0,0,1,1,1,1,3,1,1,1,0,1,1,0,1,1,1,0,1,1,0,1,1,0,0,1,1,1,1,1,3,1,1,0,1,0,2,1,1,1,0,2,0,1,1,0,0,0,2,0,0,0,1,2,0,0,2,1,3,1,3,0,1,0,1,2,0,1,0,1,2,0,0,2,0,0,0,0,1,0,1,2,1,0,2,1,1,0,1,3,0,1,1,0,1,1,0,0,1,1,2,3,0,0,0,1,1,1,1,0,2,2,0,2,1,1,0,1,2,1,2,1,0,1,0,3,1,0,1,0,0,1,1,0,0,1,1,1,0,1,1,1,1,1,0,0,0,0,1,1,1,1,0,0,0,0,1,0,1,0,1,1,1,0,1};
// {0,0,0,0,1,1,0,1,0,0,2,0,2,1,1,1,0,2,1,1,1,2,3,1,0,1,1,1,1,1,0,0,0,0,0,1,1,1,0,1,0,0,1,1,1,0,0,0,0,1,0,1,1,1,1,1,1,1,1,0,1,1,3,0,0,1,0,0,0,0,0,0,1,0,0,1,0,0,1,0,3,0,0,0,0,0,1,1,1,0,0,1,1,1,1,1,3,0,1,1,0,1,1,1,1,0,1,0,0,0,1,0,1,1,1,1,3,0,0,1,0,2,0,1,0,0,2,0,0,0,0,0,0,1,0,1,2,1,1,1,1,2,1,1,0,1,3,0,0,1,0,0,0,0,0,0,1,0,0,0,0,1,0,0,0,0,0,1,3,0,0,0,0,1,0,1,0,0,1,1,1,1,1,3,0,2,1,1,2,0,0,0,0,3,0,1,0,1,0,0,0,0,0,0,1,1,1,1,1,1,1,1,1,0,0,0,0,1,1,1,1,1,1,0,0,1,1,0,1,0,1,0,0};
KnabeGRN z=new KnabeGRN(geno);
input y=z.getIn();
fitness x=z.getFit();
z.live2(y,x,400);
System.out.println("Fitness is "+x.getFitness());
 */

/*
//FOR average fitness of random individuals
KnabeGRN.geneNo=5;
int[] genome=new int[KnabeGRN.geneNo*10+39];//12:4 for a cis site + 2 for cis delimiters + 4 for protein produced + 2 for gene delimiters
java.util.Random rand=new java.util.Random();
int next;
for(int i=0;i<genome.length;i++){
  next=rand.nextInt(2);
  //System.out.print(next+",");
  genome[i]=next;
}
for(int i=0;i<KnabeGRN.geneNo;i++){
  genome[i*10+9]=3;
  genome[i*10+4]=2;
}
*/
}//end main method

}//end main class