/*Only generate positive part of sine curve,
  negative part returns always 0
  (sinus curve shifted to get output \in [0,1]
  see +1.0/2.0)

*/
import java.awt.*;
 
public class posSigInp implements input { 

public int counter;
public double wl;
public double stdDev;
public boolean useNoise;
public static java.util.Random rand=new java.util.Random();


public void initRand(long seed){
rand=new java.util.Random(seed);
}

/*parameter specifies wavelength...
*/
public posSigInp(int wavelength,double stdDev){
counter=0;
this.stdDev=stdDev;
useNoise=false;
if(stdDev!=.0)
  useNoise=true;
wl=(2.0*Math.PI)/(wavelength*1.0);
}

/*parameter specifies wavelength...
*/
public posSigInp(int wavelength){
this(wavelength,.0);
}

public static double aboveZero(double in){
if(in<.0)
  return .0;
else
  return in;
}

/*This gives input to an individual, every 
  time step - over time a sigmoidal curve
*/
public double getVal(){
counter++;
double res=Math.sin(wl*(counter*1.0));
if(res>.0){
  if(!useNoise)
    return (res+1.0)/2.0;
  else
    return aboveZero(((res+1.0)/2.0)+(rand.nextGaussian()*stdDev));
  }
else
  return .0;
}

}